<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'ShipmentRequest' => '\\StructType\\ShipmentRequest',
            'Shipment' => '\\StructType\\Shipment',
            'ShipmentDetails' => '\\StructType\\ShipmentDetails',
            'ShipmentService' => '\\StructType\\ShipmentService',
            'Standard' => '\\StructType\\Standard',
            'Address' => '\\StructType\\Address',
            'Position' => '\\StructType\\Position',
            'Articles' => '\\StructType\\Articles',
            'Dangerousgoods' => '\\StructType\\Dangerousgoods',
            'Avis' => '\\StructType\\Avis',
            'ExpressNextDay' => '\\StructType\\ExpressNextDay',
            'Express10' => '\\StructType\\Express10',
            'Express12' => '\\StructType\\Express12',
            'FixZustelldatum' => '\\StructType\\FixZustelldatum',
            'Fix10' => '\\StructType\\Fix10',
            'Fix12' => '\\StructType\\Fix12',
            'Metro' => '\\StructType\\Metro',
            'Rewe' => '\\StructType\\Rewe',
            'ToomRewe' => '\\StructType\\ToomRewe',
            'Pickup' => '\\StructType\\Pickup',
            'InboundNational' => '\\StructType\\InboundNational',
            'InboundInternational' => '\\StructType\\InboundInternational',
            'Eurapid' => '\\StructType\\Eurapid',
            'PrivateDomestic' => '\\StructType\\PrivateDomestic',
            'AddressConsignor' => '\\StructType\\AddressConsignor',
            'AddressConsignee' => '\\StructType\\AddressConsignee',
            'AddressConsigneeFIH' => '\\StructType\\AddressConsigneeFIH',
            'AddressInboundConsignee' => '\\StructType\\AddressInboundConsignee',
            'AddressInboundInternationalConsignor' => '\\StructType\\AddressInboundInternationalConsignor',
            'AddressOptionalConsignee' => '\\StructType\\AddressOptionalConsignee',
            'AddressNeutralConsignor' => '\\StructType\\AddressNeutralConsignor',
            'PositionDetails' => '\\StructType\\PositionDetails',
            'PositionDetailsPickup' => '\\StructType\\PositionDetailsPickup',
            'ArticleDetails' => '\\StructType\\ArticleDetails',
            'DangerousgoodsDetails' => '\\StructType\\DangerousgoodsDetails',
            'ShipmentResponse' => '\\StructType\\ShipmentResponse',
            'Positions' => '\\StructType\\Positions',
            'ShipmentReject' => '\\StructType\\ShipmentReject',
            'AX4ShipmentValidation' => '\\StructType\\AX4ShipmentValidation',
            'Error' => '\\StructType\\Error',
            'General' => '\\StructType\\General',
            'ShipmentDeletionRequest' => '\\StructType\\ShipmentDeletionRequest',
            'ShipmentDeletionResponse' => '\\StructType\\ShipmentDeletionResponse',
            'ShipmentDeletionReject' => '\\StructType\\ShipmentDeletionReject',
            'ManifestRequest' => '\\StructType\\ManifestRequest',
            'ManifestResponse' => '\\StructType\\ManifestResponse',
            'Manifest' => '\\StructType\\Manifest',
            'ManifestReject' => '\\StructType\\ManifestReject',
            'DocumentsRequest' => '\\StructType\\DocumentsRequest',
            'DocumentType' => '\\StructType\\DocumentType',
            'Loadinglist' => '\\StructType\\Loadinglist',
            'Barcode' => '\\StructType\\Barcode',
            'DocumentsResponse' => '\\StructType\\DocumentsResponse',
            'DocumentsReject' => '\\StructType\\DocumentsReject',
            'ShipmentValidationRequest' => '\\StructType\\ShipmentValidationRequest',
            'ShipmentValidationResponse' => '\\StructType\\ShipmentValidationResponse',
            'ShipmentValidationReject' => '\\StructType\\ShipmentValidationReject',
            'RoutingRequest' => '\\StructType\\RoutingRequest',
            'RoutingService' => '\\StructType\\RoutingService',
            'RoutingResponse' => '\\StructType\\RoutingResponse',
            'RoutingReject' => '\\StructType\\RoutingReject',
        );
    }
}
