<?php

namespace EnumType;

use \WsdlToPhp\PackageBase\AbstractStructEnumBase;

/**
 * This class stands for codelistInboundService EnumType
 * @subpackage Enumerations
 */
class CodelistInboundService extends AbstractStructEnumBase
{
    /**
     * Constant for value 'STD'
     * Meta information extracted from the WSDL
     * - documentation: Standard | Standard
     * @return string 'STD'
     */
    const VALUE_STD = 'STD';
    /**
     * Constant for value 'XND'
     * Meta information extracted from the WSDL
     * - documentation: Express nächster Tag (nur Deutschland) | Express next day (only Germany)
     * @return string 'XND'
     */
    const VALUE_XND = 'XND';
    /**
     * Constant for value 'X10'
     * Meta information extracted from the WSDL
     * - documentation: Express bis 10 Uhr (nur Deutschland) | Express til 10 (only Germany)
     * @return string 'X10'
     */
    const VALUE_X_10 = 'X10';
    /**
     * Constant for value 'X12'
     * Meta information extracted from the WSDL
     * - documentation: Express bis 12 Uhr (nur Deutschland) | Express til 12 (only Germany)
     * @return string 'X12'
     */
    const VALUE_X_12 = 'X12';
    /**
     * Constant for value 'FND'
     * Meta information extracted from the WSDL
     * - documentation: Fixtermin Zustelldatum (nur Deutschland) | Fixed day (only Germany)
     * @return string 'FND'
     */
    const VALUE_FND = 'FND';
    /**
     * Constant for value 'F12'
     * Meta information extracted from the WSDL
     * - documentation: Fixtermin bis 10 Uhr (nur Deutschland) | Fixed day til 10 (only Germany)
     * @return string 'F12'
     */
    const VALUE_F_12 = 'F12';
    /**
     * Constant for value 'F10'
     * Meta information extracted from the WSDL
     * - documentation: Fixtermin bis 12 Uhr (nur Deutschland) | Fixed day til 12 (only Germany)
     * @return string 'F10'
     */
    const VALUE_F_10 = 'F10';
    /**
     * Return allowed values
     * @uses self::VALUE_STD
     * @uses self::VALUE_XND
     * @uses self::VALUE_X_10
     * @uses self::VALUE_X_12
     * @uses self::VALUE_FND
     * @uses self::VALUE_F_12
     * @uses self::VALUE_F_10
     * @return string[]
     */
    public static function getValidValues()
    {
        return array(
            self::VALUE_STD,
            self::VALUE_XND,
            self::VALUE_X_10,
            self::VALUE_X_12,
            self::VALUE_FND,
            self::VALUE_F_12,
            self::VALUE_F_10,
        );
    }
}
