<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ManifestResponse StructType
 * @subpackage Structs
 */
class ManifestResponse extends AbstractStructBase
{
    /**
     * The Manifest
     * Meta information extracted from the WSDL
     * - choice: Manifest
     * - choiceMaxOccurs: 1
     * - choiceMinOccurs: 1
     * @var \StructType\Manifest
     */
    public $Manifest;
    /**
     * Constructor method for ManifestResponse
     * @uses ManifestResponse::setManifest()
     * @param \StructType\Manifest $manifest
     */
    public function __construct(\StructType\Manifest $manifest = null)
    {
        $this
            ->setManifest($manifest);
    }
    /**
     * Get Manifest value
     * @return \StructType\Manifest|null
     */
    public function getManifest()
    {
        return isset($this->Manifest) ? $this->Manifest : null;
    }
    /**
     * This method is responsible for validating the value passed to the setManifest method
     * This method is willingly generated in order to preserve the one-line inline validation within the setManifest method
     * This has to validate that the property which is being set is the only one among the given choices
     * @param mixed $value
     * @return string A non-empty message if the values does not match the validation rules
     */
    public function validateManifestForChoiceConstraintsFromSetManifest($value)
    {
        $message = '';
        if (is_null($value)) {
            return $message;
        }
        $properties = [
        ];
        try {
            foreach ($properties as $property) {
                if (isset($this->{$property})) {
                    throw new \InvalidArgumentException(sprintf('The property Manifest can\'t be set as the property %s is already set. Only one property must be set among these properties: Manifest, %s.', $property, implode(', ', $properties)), __LINE__);
                }
            }
        } catch (\InvalidArgumentException $e) {
            $message = $e->getMessage();
        }
        return $message;
    }
    /**
     * Set Manifest value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\Manifest $manifest
     * @return \StructType\ManifestResponse
     */
    public function setManifest(\StructType\Manifest $manifest = null)
    {
        // validation for constraint: choice(Manifest)
        if ('' !== ($manifestChoiceErrorMessage = self::validateManifestForChoiceConstraintsFromSetManifest($manifest))) {
            throw new \InvalidArgumentException($manifestChoiceErrorMessage, __LINE__);
        }
        if (is_null($manifest) || (is_array($manifest) && empty($manifest))) {
            unset($this->Manifest);
        } else {
            $this->Manifest = $manifest;
        }
        return $this;
    }
}
