<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ShipmentDeletionReject StructType
 * @subpackage Structs
 */
class ShipmentDeletionReject extends AbstractStructBase
{
    /**
     * The AX4ShipmentValidation
     * Meta information extracted from the WSDL
     * - choice: AX4ShipmentValidation | General
     * - choiceMaxOccurs: 1
     * - choiceMinOccurs: 1
     * @var \StructType\AX4ShipmentValidation
     */
    public $AX4ShipmentValidation;
    /**
     * The General
     * Meta information extracted from the WSDL
     * - choice: AX4ShipmentValidation | General
     * - choiceMaxOccurs: 1
     * - choiceMinOccurs: 1
     * @var \StructType\General
     */
    public $General;
    /**
     * Constructor method for ShipmentDeletionReject
     * @uses ShipmentDeletionReject::setAX4ShipmentValidation()
     * @uses ShipmentDeletionReject::setGeneral()
     * @param \StructType\AX4ShipmentValidation $aX4ShipmentValidation
     * @param \StructType\General $general
     */
    public function __construct(\StructType\AX4ShipmentValidation $aX4ShipmentValidation = null, \StructType\General $general = null)
    {
        $this
            ->setAX4ShipmentValidation($aX4ShipmentValidation)
            ->setGeneral($general);
    }
    /**
     * Get AX4ShipmentValidation value
     * @return \StructType\AX4ShipmentValidation|null
     */
    public function getAX4ShipmentValidation()
    {
        return isset($this->AX4ShipmentValidation) ? $this->AX4ShipmentValidation : null;
    }
    /**
     * This method is responsible for validating the value passed to the setAX4ShipmentValidation method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAX4ShipmentValidation method
     * This has to validate that the property which is being set is the only one among the given choices
     * @param mixed $value
     * @return string A non-empty message if the values does not match the validation rules
     */
    public function validateAX4ShipmentValidationForChoiceConstraintsFromSetAX4ShipmentValidation($value)
    {
        $message = '';
        if (is_null($value)) {
            return $message;
        }
        $properties = [
            'General',
        ];
        try {
            foreach ($properties as $property) {
                if (isset($this->{$property})) {
                    throw new \InvalidArgumentException(sprintf('The property AX4ShipmentValidation can\'t be set as the property %s is already set. Only one property must be set among these properties: AX4ShipmentValidation, %s.', $property, implode(', ', $properties)), __LINE__);
                }
            }
        } catch (\InvalidArgumentException $e) {
            $message = $e->getMessage();
        }
        return $message;
    }
    /**
     * Set AX4ShipmentValidation value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\AX4ShipmentValidation $aX4ShipmentValidation
     * @return \StructType\ShipmentDeletionReject
     */
    public function setAX4ShipmentValidation(\StructType\AX4ShipmentValidation $aX4ShipmentValidation = null)
    {
        // validation for constraint: choice(AX4ShipmentValidation, General)
        if ('' !== ($aX4ShipmentValidationChoiceErrorMessage = self::validateAX4ShipmentValidationForChoiceConstraintsFromSetAX4ShipmentValidation($aX4ShipmentValidation))) {
            throw new \InvalidArgumentException($aX4ShipmentValidationChoiceErrorMessage, __LINE__);
        }
        if (is_null($aX4ShipmentValidation) || (is_array($aX4ShipmentValidation) && empty($aX4ShipmentValidation))) {
            unset($this->AX4ShipmentValidation);
        } else {
            $this->AX4ShipmentValidation = $aX4ShipmentValidation;
        }
        return $this;
    }
    /**
     * Get General value
     * @return \StructType\General|null
     */
    public function getGeneral()
    {
        return isset($this->General) ? $this->General : null;
    }
    /**
     * This method is responsible for validating the value passed to the setGeneral method
     * This method is willingly generated in order to preserve the one-line inline validation within the setGeneral method
     * This has to validate that the property which is being set is the only one among the given choices
     * @param mixed $value
     * @return string A non-empty message if the values does not match the validation rules
     */
    public function validateGeneralForChoiceConstraintsFromSetGeneral($value)
    {
        $message = '';
        if (is_null($value)) {
            return $message;
        }
        $properties = [
            'AX4ShipmentValidation',
        ];
        try {
            foreach ($properties as $property) {
                if (isset($this->{$property})) {
                    throw new \InvalidArgumentException(sprintf('The property General can\'t be set as the property %s is already set. Only one property must be set among these properties: General, %s.', $property, implode(', ', $properties)), __LINE__);
                }
            }
        } catch (\InvalidArgumentException $e) {
            $message = $e->getMessage();
        }
        return $message;
    }
    /**
     * Set General value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\General $general
     * @return \StructType\ShipmentDeletionReject
     */
    public function setGeneral(\StructType\General $general = null)
    {
        // validation for constraint: choice(AX4ShipmentValidation, General)
        if ('' !== ($generalChoiceErrorMessage = self::validateGeneralForChoiceConstraintsFromSetGeneral($general))) {
            throw new \InvalidArgumentException($generalChoiceErrorMessage, __LINE__);
        }
        if (is_null($general) || (is_array($general) && empty($general))) {
            unset($this->General);
        } else {
            $this->General = $general;
        }
        return $this;
    }
}
